package com.zy.bms.controller.wx;

import com.zy.bms.common.ServerResponse;
import com.zy.bms.common.controller.BaseController;
import com.zy.bms.common.io.wechat.*;
import com.zy.bms.service.RelationService;
import com.zy.bms.service.SetService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * 设备设置相关
 *
 * @author yang xiao kun
 * create on 2021/1/21
 */
@RestController
@RequestMapping("zy4g/api/set")
public class SetController extends BaseController {

    @Resource
    private SetService setService;
    @Resource
    private RelationService relationService;

    /**
     * 校验设备是否是该用户的设备
     */
    private boolean verify(SimpleSetIO io) {
        boolean flag = relationService.checkDeviceIsBelongByDeviceId(getUserId(), io.getDeviceId());
        if (!flag) {
            System.out.println("非法请求----" + getUserId() + "-----" + io.getDeviceId());
        }
        return flag;
    }

    /**
     * 设置音量
     */
    @PostMapping("volume.do")
    public ServerResponse setVolume(VolumeSetIO io) {
        if (verify(io)) setService.setVolume(io);
        return ServerResponse.createBySuccess();
    }

    /**
     * 设置定位频率
     */
    @PostMapping("gpsRate.do")
    public ServerResponse gpsRate(GpsRateSetIO io) {
        if (verify(io)) setService.setGpsRate(io);
        return ServerResponse.createBySuccess();
    }

    /**
     * 自动接听
     *
     * @param io 设置参数
     */
    @PostMapping("autoAnswer.do")
    public ServerResponse setAutoAnswer(AnswerSetIO io) {
        if (verify(io)) setService.setAutoAnswer(io);
        return ServerResponse.createBySuccess();
    }

    /**
     * 设置语音播报
     */
    @PostMapping("news.do")
    public ServerResponse setNews(NewsSetIO io) {
        if (verify(io)) setService.setNews(io);
        return ServerResponse.createBySuccess();
    }

    /**
     * 设置SOS紧急呼叫
     */
    @PostMapping("sos.do")
    public ServerResponse setSOS(SosSetIO io) {
        if (verify(io)) setService.setSOS(io);
        return ServerResponse.createBySuccess();
    }

    /**
     * 设置持续定位
     */
    @PostMapping("continue.do")
    public ServerResponse setContinue(ContinueSetIO io) {
        if (verify(io)) setService.setContinue(io);
        return ServerResponse.createBySuccess();
    }
}
